#!/usr/bin/python
import docker
import json
import subprocess
client = docker.from_env()

# Publica contenedores Docker
print "containers"
for container in client.containers.list():
	if not ('service' in container.name):
		print container.name
                strport=container.attrs['Config']['ExposedPorts']
        	if ('public' in container.name) and strport:
				if('cluster' in container.name):
					cmd='publish_alt'
					tipo='Cluster'
				else:
					cmd='publish'
					tipo='Docker'
                		ecode=json.dumps(strport)
                		dcode=json.loads(ecode)
                		prot=dcode.keys()[0]
                		dprot=prot.split('/')
				port=dprot[0]
                		img=container.attrs['Config']['Image']
                		name=container.name[0:container.name.find('_public')]
                		subprocess.call(['/usr/sbin/avahi-ps', cmd, img + '_' + name, tipo, port, ""])
				print '/usr/sbin/avahi-ps ' + cmd + ' ' +  img + '_' + name + ' ' + tipo + ' ' + port

# Publica servicios Docker swarm
print "services" 
for service in client.services.list():
        if ('service' in service.name):
		print service.name
                strport=str(service.attrs['Endpoint']['Ports'][0]['PublishedPort'])
                if ('public' in service.name) and strport:
                	cmd='publish_alt'
                	tipo='Service'
			img = ""
                        subprocess.call(['/usr/sbin/avahi-ps', cmd, service.name, tipo, strport, ""])
                        print '/usr/sbin/avahi-ps ' + cmd + ' ' +  service.name + ' ' + tipo + ' ' + strport

